"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const recommended_1 = require("./configs/recommended");
const best_practice_1 = require("./configs/best-practice");
const attach_shadow_constructor_1 = require("./rules/attach-shadow-constructor");
const guard_super_call_1 = require("./rules/guard-super-call");
const no_closed_shadow_root_1 = require("./rules/no-closed-shadow-root");
const no_constructor_attributes_1 = require("./rules/no-constructor-attributes");
const no_invalid_element_name_1 = require("./rules/no-invalid-element-name");
const no_self_class_1 = require("./rules/no-self-class");
const no_typos_1 = require("./rules/no-typos");
exports.rules = {
    'attach-shadow-constructor': attach_shadow_constructor_1.default,
    'guard-super-call': guard_super_call_1.default,
    'no-closed-shadow-root': no_closed_shadow_root_1.default,
    'no-constructor-attributes': no_constructor_attributes_1.default,
    'no-invalid-element-name': no_invalid_element_name_1.default,
    'no-self-class': no_self_class_1.default,
    'no-typos': no_typos_1.default
};
exports.configs = {
    recommended: recommended_1.default,
    'best-practice': best_practice_1.default
};
