"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Determines if a node is an element class or not.
 *
 * @param {ESTree.Node} node Node to test
 * @param {AST.Token=} jsdoc JSDoc to parse
 * @return {boolean}
 */
function isCustomElement(node, jsdoc) {
    return ((node.type === 'ClassExpression' || node.type === 'ClassDeclaration') &&
        ((node.superClass &&
            node.superClass.type === 'Identifier' &&
            node.superClass.name === 'HTMLElement') ||
            (jsdoc !== undefined &&
                jsdoc !== null &&
                jsdoc.value.includes('@customElement'))));
}
exports.isCustomElement = isCustomElement;
/**
 * Determines if a node is an extension of HTMLElement class or not.
 *
 * @param {ESTree.Node} node Node to test
 * @return {boolean}
 */
function isNativeCustomElement(node) {
    return ((node.type === 'ClassExpression' || node.type === 'ClassDeclaration') &&
        node.superClass !== undefined &&
        node.superClass !== null &&
        node.superClass.type === 'Identifier' &&
        node.superClass.name === 'HTMLElement');
}
exports.isNativeCustomElement = isNativeCustomElement;
